<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2010 osCommerce

  Released under the GNU General Public License
*/

// UCC MODULE
class bm_ucc {
    var $code = 'bm_ucc';
    var $group = 'boxes';
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    /**
     * bm_ucc constructor.
     */
    public function bm_ucc() {
        $this->title = MODULE_BOXES_UCC_TITLE;
        $this->description = MODULE_BOXES_UCC_DESCRIPTION;
        if (defined('MODULE_BOXES_UCC_STATUS')) {
            $this->sort_order = MODULE_BOXES_UCC_SORT_ORDER;
            $this->enabled = (MODULE_BOXES_UCC_STATUS == 'True');
            $this->group = 'header_tags';
        }
    }

    /**
     * On install
     */
    public function install() {
        tep_db_query("alter table products add ean VARCHAR (255)");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable UCC Module', 'MODULE_BOXES_UCC_STATUS', 'True', 'Do you want to add the module to your shop?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_BOXES_UCC_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
    }

    /**
     * On remove
     */
    public function remove() {
        tep_db_query("alter table products drop column ean");
        tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    /**
     * On config load
     * @return bool
     */
    public function isEnabled() {
        return $this->enabled;
    }

    /**
     * On config load
     * @return bool
     */
    public function check() {
        return defined('MODULE_BOXES_UCC_STATUS');
    }

    /**
     * It can add block somewhere
     */
    public function execute() {
        global $oscTemplate;

        if ($this->check()) {
            $data = "<script type='text/javascript' src='https://app.ucancommerce.com/assets/scripts/ucc-pixel.js'></script>";
            $oscTemplate->addBlock($data, $this->group);
        }
    }

    /**
     * Helper
     * @return string[]
     */
    public function keys() {
        return array('MODULE_BOXES_UCC_STATUS', 'MODULE_BOXES_UCC_SORT_ORDER');
    }
}
